// Enable debug prints to serial monitor
#define MY_DEBUG 

// Enable and select radio type attached

#define MY_RADIO_NRF5_ESB
//#define MY_PASSIVE_NODE
#define MY_NODE_ID 60
//#define MY_PARENT_NODE_ID AUTO
#define CHILD_ID_TEMP 0
#define CHILD_ID_HUM 1
#define CHILD_ID_PRESSURE 2
#define POWER_CHILD_ID 100
#define BAT_COOF 5.95

//#define BAT_COOF 2.95    //????

//#define BAT_MIN 250
//#define BAT_MAX 300

#define BAT_MIN 360
#define BAT_MAX 600

unsigned long SLEEP_TIME = 600000; // 10 минут

bool change;
uint16_t temp1;
float vcc;
int battery;
int old_battery;

uint32_t send_batteryTime = 7200000;
//uint32_t send_batteryTime = 7200;
unsigned long w_battetyTime = 0;
bool chek_h = true;
boolean first_send_battery = 1;

//#include <SPI.h>
#include <MySensors.h>
#include <Wire.h>

#include <BME280I2C.h>
// датчик температуры, давления и влажности
BME280I2C bme; 

   float temp(NAN), hum(NAN), pres(NAN); 


MyMessage msgHum(CHILD_ID_HUM, V_HUM);
MyMessage msgPress(CHILD_ID_PRESSURE, V_PRESSURE);
MyMessage msgTemp(CHILD_ID_TEMP, V_TEMP);
MyMessage powerMsg(POWER_CHILD_ID, V_VAR1);

void before()
{
  NRF_POWER->DCDCEN = 1;
  sleep(400);
}
void presentation() {
  // Send the sketch version information to the gateway and Controller
  sendSketchInfo("BME_280 Sensor", "1.52");
wait(100);
  // Register binary input sensor to sensor_node (they will be created as child devices)
  // You can use S_DOOR, S_MOTION or S_LIGHT here depending on your usage. 
  // If S_LIGHT is used, remember to update variable type you send in. See "msg" above.
  present(CHILD_ID_TEMP, S_TEMP, "Temperature sensor");
  wait(100);
  present(CHILD_ID_HUM, S_HUM, "Humidity sensor");
  wait(100);
  present(CHILD_ID_PRESSURE, S_BARO, "Pressure sensor");
} 
void setup()  
{ 

  disableNfc();
  turnOffAdc();
   bme.begin();
   readBatLev();
 
}
void loop() 
{

  bme.read(pres, temp, hum, true, B101); 
     // generate some random data
  send(msgHum.set(hum, 1));

  send(msgPress.set(pres, 1));

  send(msgTemp.set(temp ,1));

  sleep(SLEEP_TIME);
  sleep(1000);

}  

void readBatLev() {
  NRF5_ESB_startListening();
  wait(300);
  temp1 = analogRead(29);
  //vcc = temp * 3.0 / 1024 * BAT_COOF * 100;
  vcc = temp1 * 0.018 * 100;
  battery = map((int)vcc, BAT_MIN, BAT_MAX, 0, 100);
  if (battery < 0) {
    battery = 0;
  }
  if (battery > 100) {
    battery = 100;
  }
  if (first_send_battery == 1) {
    first_send_battery = 0;
    send(powerMsg.set(temp1));
    sendBatteryLevel(battery);
    TRANSPORT_DEBUG(PSTR("MyS: SEND BATTERY LEVEL\n"));
    TRANSPORT_DEBUG(PSTR("MyS: BATTERY LEVEL ADC: %d\n"), temp1);
    old_battery = battery;
  } else {
    if (old_battery != battery) {
      if (battery < old_battery) {
        old_battery = battery;
        sendBatteryLevel(battery);
        TRANSPORT_DEBUG(PSTR("MyS: SEND BATTERY LEVEL\n"));
        TRANSPORT_DEBUG(PSTR("MyS: BATTERY LEVEL ADC: %d\n"), temp1);
        change = 1;
      } else {
        battery = old_battery;
      }
    }
  }
}
void disableNfc() {  //only applied to nRF52
  //Make pins 9 and 10 usable as GPIO pins.
  NRF_NFCT->TASKS_DISABLE = 1; //disable NFC
  NRF_NVMC->CONFIG = 1; // Write enable the UICR
  NRF_UICR->NFCPINS = 0; //Make pins 9 and 10 usable as GPIO pins.
  NRF_NVMC->CONFIG = 0; // Put the UICR back into read-only mode.
}

void turnOffRadio() {
  NRF_RADIO->TASKS_DISABLE = 1;
  while (!(NRF_RADIO->EVENTS_DISABLED)) {}  //until radio is confirmed disabled
}

void turnOffAdc() {
  if (NRF_SAADC->ENABLE) { //if enabled, then disable the SAADC
    NRF_SAADC->TASKS_STOP = 1;
    while (NRF_SAADC->EVENTS_STOPPED) {} //wait until stopping of SAADC is confirmed
    NRF_SAADC->ENABLE = 0; //disable the SAADC
    while (NRF_SAADC->ENABLE) {} //wait until the disable is confirmed
  }
}

void turnOffHighFrequencyClock() {
  NRF_CLOCK->TASKS_HFCLKSTOP = 1;
  while ((NRF_CLOCK->HFCLKSTAT) & 0x0100) {}  //wait as long as HF clock is still running.
}

void mySleepPrepare() {  //turn-off energy drains prior to sleep
  turnOffHighFrequencyClock();
  turnOffRadio();
  NRF_UART0->ENABLE = 0;
}
